['.',ENV['HOME']].find do |d| p=File.expand_path('.ikra.conf',d)
File.exists?(p) && load(p) end

# TODO: support nvcc
def usage()
  STDERR.puts "usage: ruby #{__FILE__} [--cc | --cuda] [--debug]"
  exit 1
end

$DEBUG_OPTION=false
libname=nil

while ARGV.size > 0
  case ARGV.shift
  when "--cc" then
    libname="parray_c"
  when "--cuda" then
    $CUDA=true
    libname="parray_cuda"
    require 'fileutils'
    FileUtils.copy("parray_c.cc", "parray_cuda.cu", :verbose=>true)
  when "--debug" then
    $DEBUG_OPTION=true
  when "--nodebug" then
    $DEBUG_OPTION=false
  else
    usage
  end
end

usage if libname==nil
  
PARRAY_C_DIR=File.expand_path("proto/parray/",IKRA_HOME)
load "../../src/extconf.rb"

CONFIG['CPPFLAGS'] += " -DINIT_FUNCTION_NAME=Init_#{libname}#{$DEBUG_OPTION ? "_debug" : ""}"
init_mkmf
dir_config('',PARRAY_C_DIR);

create_makefile libname + ($DEBUG_OPTION ? "_debug" : "")
