(* This is the interface of CUDA backend.  This is the same as the one
   defined at the beginnig of convert.ml. *)

(* TODO: share this signature definition with convert.ml. *)

type kind = Initialize | Map | Reduce | UnitlessReduce
val string_of_kind : kind -> string
val element_type_of : Ikra_type.t -> Ikra_type.t
type kernel = {
  kind : kind;
  name : string;
  free_vars : Ast.tast list;
  params : Ast.parameter_pattern;
  type_decls : Ast.type_decl list;
  body : Ast.tast list;
  body_type : Ikra_type.t;
  receiver : Ast.tast;
  top_decls : Ast.tast;
  return_type : Ikra_type.t;
}
val top_decls : kernel list -> Ast.tast list
type var_iname_type_cname = Ast.tast * string
type env = {
  wrapper_name : string;
  kernel_fun_name : string;
  body_fun_name : string;
  argspecs : var_iname_type_cname list;
  body_ctype : Cuda.cuda_type;
  fvspecs : (Ast.tast * string) list;
  body_args : (Cuda.cuda_type * Cuda.variable) list;
  element_statements : Cuda.statement list;
}
val generate_makefile : generate_only:bool -> Convert_env.t -> unit
val cuda_code_of : string -> kernel list -> string

val cxx_suffix : string
val backend_name : string 

val generate_tuple_type_decls : string -> kernel list -> string
