(* val path_to_ruby : string *)
(* val path_to_parser : string *)
type sexp =
    Sexp_symbol of string
  | Sexp_nil
  | Sexp_list of sexp list
  | Sexp_int of int
  | Sexp_float of float
  | Sexp_str of string
  | Sexp_bool of bool
  | Sexp_range of int * int
val string_of_sexp : sexp -> string
(* val symbol_of_sexp : sexp -> string *)
val ruby_parse_file : string -> string
(* val literal_range_pattern : string *)
(* val literal_range_regexp : Str.regexp *)
(* val tokenizing_regexp : Str.regexp *)
(* val parse_literal : string -> sexp *)
val parse_sexp : string list -> sexp * string list
(* val parse_sexp_list : sexp list -> string list -> sexp list * string list *)
val parse_sexp_string : string -> sexp
(* val add_block : Ast.tast * Ast.tast -> Ast.tast *)
(* val ast_of_sexp_maybe : sexp -> Ast.tast option *)
(* val block_parameters_of_sexp : sexp -> Ast.parameter_pattern *)
(* val block_of_sexp : sexp -> sexp -> Ast.tast *)
val parse_file : string -> Ast.tast


val tokenize_sexp : string -> string list (* used in a test *)
val ast_of_sexp : sexp -> Ast.tast      (* used in a test *)
