type 'a node = {
  element : 'a;
  next : 'a node list ref;
  index : int ref;
  lowlink : int ref;
}
type 'a graph = 'a node list
type 'a scc = 'a node list
type 'a tarjan_result = 'a scc list
type 'a state_t = 'a tarjan_result * int * 'a node list
val make_node : 'a -> 'a node
val connect : 'a node -> 'a node -> unit
val string_of : int node -> string
val string_of_scc : int node list -> string
val string_of_sccs : int node list list -> string
val visited_p : 'a node -> bool
val strongconnect : 'a state_t -> 'a node -> 'a state_t
val traverse : 'a node -> 'a state_t -> 'a state_t
val build_scc : 'a node -> 'a node list -> 'a state_t -> 'a state_t
val tarjan : 'a graph -> 'a state_t
val sccs : 'a list -> ('a * 'a) list -> 'a list list
