open OUnit2

(* test if ikrac can pass parameters to .rb that start with "-".

   e.g., "--gen" should be passed to myprogram.rb in the following
   command line:

           ikrac --backend cuda -- myprogram.rb --gen abc
   

*)

let run_ikrac : (string -> string array) -> 'a =
  fun args ->
    Util.with_temp_file "test" ".rb" 
      "v=ARGV[0].to_i; 
        puts Array.new(1){ |x| v }.
                   reduce(0){|x,y| x+y }"
      (fun rb_file ->
         assert_equal ~printer:(fun s->s)
         "-123"
           (Frontend.parse_and_compile ~redirect:true (args rb_file)))

let suite =
  "suite">:::
    [
      "pass minus before rb">::(fun _ ->
        run_ikrac (fun rb_file -> [|"dummy"; "--"; rb_file; "-123" |]));
      
      "pass minus after rb">::(fun _ ->
        run_ikrac (fun rb_file -> [|"dummy"; rb_file; "--"; "-123" |]));
    ]

let _ = Config.initialize None

let () =
  run_test_tt_main suite

